procedure calc-price-proc:
   def input parameter room-type as integer.
   def input parameter date1 as date.
   def input parameter date2 as date.
   def output parameter price as decimal init ?.
   def output parameter err as char init ?.

/* find rates which overlap the accomodation dates  */
DEF VAR lastValidDate AS DATE.
lastValidDate = ?.

FOR EACH rate WHERE rate.room-type = room-type AND
   NOT ((rate.start-date < date1 AND rate.end-date < date1) OR 
        (rate.start-date >= date2 AND rate.end-date >= date2)) 
   BY rate.start-date:
      IF lastValidDate = ? THEN DO:
         IF NOT (rate.start-date <= date1 AND date1 <= rate.end-date) THEN DO:
            err = "Cannot find rate for " + STRING(date1). 
            RETURN.
         END.

         lastValidDate = rate.end-date.
         price = rate.rate * (MIN(rate.end-date, date2 - 1) - date1 + 1).
      END.
      ELSE DO:
         IF rate.start-date <> lastValidDate + 1 THEN DO:
            err = "Cannot find rate for " + STRING(lastValidDate + 1). 
            RETURN.
         END.

         price = price + rate.rate * (MIN(rate.end-date, date2 - 1) - lastValidDate).
         lastValidDate = rate.end-date.
      END.

      IF lastValidDate >= date2 - 1 THEN DO:
         LEAVE.   
      END.
END.

IF lastValidDate = ? THEN DO:
   err = "Cannot find rate for " + STRING(date1) + "!". 
   RETURN.
END.

end procedure.