&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v7r11
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS Method-Library 
/*------------------------------------------------------------------------
Description:    Method Library for Folders
Comments:       
------------------------------------------------------------------------*/
/*          This .W file was created with the Progress UIB.             */
/*----------------------------------------------------------------------*/
/* ***************************  Definitions  ************************** */
&GLOBAL-DEFINE max-labels 20
&GLOBAL-DEFINE max-tab-rows 5
/* Definitions for button tabs */
&GLOBAL-DEFINE button-frame-height 22
&GLOBAL-DEFINE button-frame-overlap 4
&GLOBAL-DEFINE max-tab-rows 5
&GLOBAL-DEFINE selected-button-on-bottom-row TRUE
DEFINE VARIABLE LhTab AS HANDLE EXTENT {&max-labels}  NO-UNDO.
DEFINE VARIABLE LiCurrentTab AS INTEGER     NO-UNDO.
DEFINE VARIABLE LhContainer AS HANDLE NO-UNDO.
DEFINE VARIABLE LiNumTabs AS INTEGER NO-UNDO.
DEFINE VARIABLE LhTabFrame AS HANDLE EXTENT {&max-tab-rows} NO-UNDO.
DEFINE VARIABLE LhBottomRowTabFrame AS HANDLE NO-UNDO.
DEFINE VARIABLE LiNumTabFrames AS INTEGER NO-UNDO.
DEFINE VARIABLE LhTabBottomFrame AS HANDLE NO-UNDO.
DEFINE VARIABLE LhOverlayButton AS HANDLE NO-UNDO.
DEFINE VARIABLE LhOverlayButtonFrame AS HANDLE NO-UNDO.
DEFINE VARIABLE LhBackgroundFrame AS HANDLE NO-UNDO.
DEFINE VARIABLE LhBackgroundButton AS HANDLE NO-UNDO.

DEFINE VARIABLE LlOnTabFrame AS LOGICAL NO-UNDO.
DEFINE VARIABLE LlClickActive AS LOGICAL NO-UNDO.  /* Horrible, horrible code required for Homelessness */
/* Definitions to allow syntax checking when editing the method library code */
&IF     DEFINED(Procedure-Type) = 0
&THEN
    DEFINE FRAME FRAME-A.
    &SCOPED-DEFINE FRAME-NAME Folder-Frm
    DEFINE FRAME {&FRAME-NAME}.
&ENDIF
&IF DEFINED(PSelectPage) = 0 &THEN
    &SCOPED-DEFINE PSelectPage select-page
&ENDIF
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 
/* ********************  Preprocessor Definitions  ******************** */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME

/* *********************** Procedure Settings ************************ */
&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Method-Library
   Allow: 
   Frames: 0
   Add Fields to: Neither
   Other Settings: INCLUDE-ONLY
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS
/* *************************  Create Window  ************************** */
&ANALYZE-SUSPEND _CREATE-WINDOW
/* DESIGN Window definition (used by the UIB) 
  CREATE WINDOW Method-Library ASSIGN
         HEIGHT             = 14.77
         WIDTH              = 50.29.
/* END WINDOW DEFINITION */
                                                                        */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB Method-Library 
/* ************************* Included-Libraries *********************** */
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

 

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK Method-Library 

/* ***************************  Main Block  *************************** */
CREATE FRAME LhOverlayButtonFrame
        ASSIGN FRAME = FRAME {&FRAME-NAME}:HANDLE
               BOX = FALSE
               SCROLLABLE = FALSE
               .
CREATE BUTTON LhOverlayButton
    ASSIGN FRAME = /* FRAME {&FRAME-NAME}:HANDLE */ LhOverlayButtonFrame
           FONT = 10
           TRIGGERS:
              ON CURSOR-LEFT PERSISTENT RUN POverlayBtnEventCursorLeft IN THIS-PROCEDURE.
              ON CURSOR-RIGHT PERSISTENT RUN POverlayBtnEventCursorRight IN THIS-PROCEDURE.
           END TRIGGERS.
                
IF SESSION:WINDOW-SYSTEM = "MS-WIN95"
THEN DO:
    CREATE FRAME LhBackgroundFrame
        ASSIGN FRAME = FRAME {&FRAME-NAME}:HANDLE
               BOX = FALSE
               THREE-D = TRUE
               SCROLLABLE = FALSE
               .
    
    CREATE BUTTON LhBackgroundButton
        ASSIGN FRAME = LhBackgroundFrame
               .
END.
ELSE DO:
    CREATE FRAME LhBackgroundFrame
        ASSIGN FRAME = FRAME {&FRAME-NAME}:HANDLE
               BGCOLOR = 31
               BOX = TRUE
               SCROLLABLE = FALSE
               .
END.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

/* **********************  Internal Procedures  *********************** */
&IF DEFINED(EXCLUDE-PAdjustBackgroundFrame) = 0 &THEN
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE PAdjustBackgroundFrame Method-Library 
PROCEDURE PAdjustBackgroundFrame :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       NO-ERROR on the button dimension assigns because might not exist.
               Easier to read then VALID-HANDLE...
------------------------------------------------------------------------------*/
    
    DEFINE VARIABLE iClassicAdjustment AS INTEGER NO-UNDO.                                 
    
    /* Variables make the code easier to read */
    DEFINE VARIABLE iTargetFrameHeight AS INTEGER NO-UNDO.
    DEFINE VARIABLE iTargetFrameWidth AS INTEGER NO-UNDO.
    IF SESSION:WINDOW-SYSTEM="MS-WIN95"
    THEN iClassicAdjustment = 1.
        
    /* Resize/Move the frame */
    /* Vertically */
    iTargetFrameHeight = (FRAME {&FRAME-NAME}:HEIGHT-PIXELS - (({&button-frame-height} - {&button-frame-overlap}) * LiNumTabFrames)) - 2.
    IF LhBackgroundFrame:HEIGHT-PIXELS > iTargetFrameHeight /* Getting smaller */
    THEN DO: 
        LhBackgroundButton:HEIGHT-PIXELS = iTargetFrameHeight NO-ERROR.
        LhBackgroundFrame:HEIGHT-PIXELS = iTargetFrameHeight.
    END.
    LhBackgroundFrame:Y = (({&button-frame-height} - {&button-frame-overlap}) * LiNumTabFrames) + 2.
    IF LhBackgroundFrame:HEIGHT-PIXELS < iTargetFrameHeight /* Getting bigger */
    THEN DO:
        LhBackgroundFrame:HEIGHT-PIXELS = iTargetFrameHeight.
        LhBackgroundButton:HEIGHT-PIXELS = iTargetFrameHeight NO-ERROR.
    END.
    /* Horizontally */
    iTargetFrameWidth = FRAME {&FRAME-NAME}:WIDTH-PIXELS - (2 - (2 * iClassicAdjustment)).
    IF LhBackgroundFrame:WIDTH-PIXELS > iTargetFrameWidth /* Getting smaller */
    THEN DO:
        LhBackgroundButton:WIDTH-PIXELS = iTargetFrameWidth NO-ERROR.
        LhBackgroundFrame:WIDTH-PIXELS = iTargetFrameWidth.
    END.
    
    LhBackgroundFrame:X = 1 - iClassicAdjustment.
    IF LhBackgroundFrame:WIDTH-PIXELS < iTargetFrameWidth /* Getting bigger */
    THEN DO:
        LhBackgroundFrame:WIDTH-PIXELS = iTargetFrameWidth.
        LhBackgroundButton:WIDTH-PIXELS = iTargetFrameWidth NO-ERROR.
    END.
    LhOverlayButton:MOVE-TO-TOP().
    LhBackgroundFrame:MOVE-TO-TOP().
END PROCEDURE.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ENDIF
&IF DEFINED(EXCLUDE-PAssignTabsToFrames) = 0 &THEN
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE PAssignTabsToFrames Method-Library 
PROCEDURE PAssignTabsToFrames :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
    DEFINE INPUT PARAMETER IcFolderLabels AS CHARACTER NO-UNDO.
    DEFINE INPUT PARAMETER IiFrameWidth AS INTEGER NO-UNDO.
    DEFINE OUTPUT PARAMETER OcFrameLabels AS CHARACTER EXTENT {&max-tab-rows} NO-UNDO.
    DEFINE OUTPUT PARAMETER OiFramePadding AS INTEGER EXTENT {&max-tab-rows} NO-UNDO.
             
    DEFINE VARIABLE iCount AS INTEGER NO-UNDO.
    DEFINE VARIABLE iTabFrameCount AS INTEGER NO-UNDO INITIAL 0.
    DEFINE VARIABLE iNumTabFrames AS INTEGER NO-UNDO.
    DEFINE VARIABLE cLabel AS CHARACTER NO-UNDO.
    DEFINE VARIABLE iLabels AS INTEGER NO-UNDO. 
    DEFINE VARIABLE iWidthOfTab AS INTEGER NO-UNDO EXTENT {&max-labels}.
    DEFINE VARIABLE iButtonWidthPixels AS INTEGER NO-UNDO.
    DEFINE VARIABLE iFrameFirstTab AS INTEGER NO-UNDO EXTENT {&max-tab-rows}.
    DEFINE VARIABLE iTabFrameWidth AS INTEGER NO-UNDO EXTENT {&max-tab-rows}.
    DEFINE VARIABLE iNumTabsInFrame AS INTEGER NO-UNDO EXTENT {&max-tab-rows}.
    DEFINE VARIABLE lShuffled AS LOGICAL NO-UNDO.
    DEFINE VARIABLE iShuffleFrame AS INTEGER NO-UNDO.
    iLabels = NUM-ENTRIES(IcFolderLabels,"|"). /* assign, otherwise it'll count each loop! */
    
    initial-allocate-block:
    DO iCount = 1 TO iLabels:
        cLabel = ENTRY(iCount,IcFolderLabels,"|").
        
        iWidthOfTab[iCount] = FONT-TABLE:GET-TEXT-WIDTH-PIXELS(cLabel,10) + 11. /* Should be 10, but with overlaps, it's easier just to say +9, and add 1 on at the start */
        /* Set the initial frames */
        IF iTabFrameCount = 0
        OR iTabFrameWidth[iTabFrameCount] + iWidthOfTab[iCount] > IiFrameWidth 
        THEN DO:
            IF iTabFrameCount = {&max-tab-rows}
            THEN DO:
                MESSAGE "Maximum number of tab rows has been reached.  Not all tabs can be displayed" VIEW-AS ALERT-BOX WARNING.
                iLabels = iCount - 1.
                LEAVE initial-allocate-block.
            END.
            iTabFrameCount = iTabFrameCount + 1.
            iFrameFirstTab[iTabFrameCount] = iCount.
            iTabFrameWidth[iTabFrameCount] = 1. /* An initial pixel! */
        END.
        iTabFrameWidth[iTabFrameCount] = iTabFrameWidth[iTabFrameCount] + iWidthOfTab[iCount].
        
        iNumTabsInFrame[iTabFrameCount] = iNumTabsInFrame[iTabFrameCount] + 1.
    END.
    iNumTabFrames = iTabFrameCount.
    IF iNumTabFrames > 1 THEN
    /* Algorithm */
    /* Starting with the highest tab, work down */
    shuffle-block:
    REPEAT:
        lShuffled = FALSE.
        DO iShuffleFrame = iNumTabFrames TO 2 BY -1:
            /* 1
            /* Take last tab off previous frame, and add to this, if the result is less wide then go ahead and swap */
            DO WHILE iTabFrameWidth[iShuffleFrame] + iWidthOfTab[iFrameFirstTab[iShuffleFrame] - 1] < iTabFrameWidth[iShuffleFrame - 1] - iWidthOfTab[iFrameFirstTab[iShuffleFrame] - 1]:
                lShuffled = TRUE.
                iFrameFirstTab[iShuffleFrame] = iFrameFirstTab[iShuffleFrame] - 1.
                iTabFrameWidth[iShuffleFrame] = iTabFrameWidth[iShuffleFrame] + iWidthOfTab[iFrameFirstTab[iShuffleFrame]].
                iTabFrameWidth[iShuffleFrame - 1] = iTabFrameWidth[iShuffleFrame - 1] - iWidthOfTab[iFrameFirstTab[iShuffleFrame]].
            END.
            */
            /* 2 whilst the average padding of the previous is still larger then shuffle */
            /*
            DO WHILE (IiFrameWidth - (iTabFrameWidth[iShuffleFrame] + iWidthOfTab[iFrameFirstTab[iShuffleFrame] - 1])) / (iNumTabsInFrame[iShuffleFrame] + 1) > (IiFrameWidth - (iTabFrameWidth[iShuffleFrame - 1] - iWidthOfTab[iFrameFirstTab[iShuffleFrame] - 1])) / (iNumTabsInFrame[iShuffleFrame - 1] - 1):
                lShuffled = TRUE.
                
                iFrameFirstTab[iShuffleFrame] = iFrameFirstTab[iShuffleFrame] - 1.
                iTabFrameWidth[iShuffleFrame] = iTabFrameWidth[iShuffleFrame] + iWidthOfTab[iFrameFirstTab[iShuffleFrame]].
                iTabFrameWidth[iShuffleFrame - 1] = iTabFrameWidth[iShuffleFrame - 1] - iWidthOfTab[iFrameFirstTab[iShuffleFrame]].
                iNumTabsInFrame[iShuffleFrame] = iNumTabsInFrame[iShuffleFrame] + 1.
                iNumTabsInFrame[iShuffleFrame - 1] = iNumTabsInFrame[iShuffleFrame - 1] - 1.
            END.
            */
            /*
            /* or 3 both of the above... */
            DO WHILE (IiFrameWidth - (iTabFrameWidth[iShuffleFrame] + iWidthOfTab[iFrameFirstTab[iShuffleFrame] - 1])) / (iNumTabsInFrame[iShuffleFrame] + 1) > (IiFrameWidth - (iTabFrameWidth[iShuffleFrame - 1] - iWidthOfTab[iFrameFirstTab[iShuffleFrame] - 1])) / (iNumTabsInFrame[iShuffleFrame - 1] - 1)
                OR iTabFrameWidth[iShuffleFrame] + iWidthOfTab[iFrameFirstTab[iShuffleFrame] - 1] < iTabFrameWidth[iShuffleFrame - 1] - iWidthOfTab[iFrameFirstTab[iShuffleFrame] - 1]:
                lShuffled = TRUE.
                
                iFrameFirstTab[iShuffleFrame] = iFrameFirstTab[iShuffleFrame] - 1.
                iTabFrameWidth[iShuffleFrame] = iTabFrameWidth[iShuffleFrame] + iWidthOfTab[iFrameFirstTab[iShuffleFrame]].
                iTabFrameWidth[iShuffleFrame - 1] = iTabFrameWidth[iShuffleFrame - 1] - iWidthOfTab[iFrameFirstTab[iShuffleFrame]].
                iNumTabsInFrame[iShuffleFrame] = iNumTabsInFrame[iShuffleFrame] + 1.
                iNumTabsInFrame[iShuffleFrame - 1] = iNumTabsInFrame[iShuffleFrame - 1] - 1.
            END.
            */
            /* Do whilst padding is still positive for both, but would be better */
            /*
            DO WHILE iTabFrameWidth[iShuffleFrame] + iWidthOfTab[iFrameFirstTab[iShuffleFrame] - 1] < IiFrameWidth
                AND iTabFrameWidth[iShuffleFrame] + iWidthOfTab[iFrameFirstTab[iShuffleFrame] - 1] < iTabFrameWidth[iShuffleFrame - 1] - iWidthOfTab[iFrameFirstTab[iShuffleFrame] - 1]
                :
                
                lShuffled = TRUE.
                iFrameFirstTab[iShuffleFrame] = iFrameFirstTab[iShuffleFrame] - 1.
                iTabFrameWidth[iShuffleFrame] = iTabFrameWidth[iShuffleFrame] + iWidthOfTab[iFrameFirstTab[iShuffleFrame]].
                iTabFrameWidth[iShuffleFrame - 1] = iTabFrameWidth[iShuffleFrame - 1] - iWidthOfTab[iFrameFirstTab[iShuffleFrame]].
                iNumTabsInFrame[iShuffleFrame] = iNumTabsInFrame[iShuffleFrame] + 1.
                iNumTabsInFrame[iShuffleFrame - 1] = iNumTabsInFrame[iShuffleFrame - 1] - 1.
            END.
            */
            /* Lowest average padding */
            /* Variables to make easier to read */
            DEFINE VARIABLE iCurrentShuffleTabPadding AS DECIMAL NO-UNDO.
            DEFINE VARIABLE iCurrentMinusTabPadding AS DECIMAL NO-UNDO.
            DEFINE VARIABLE iNewShuffleTabPadding AS DECIMAL NO-UNDO.
            DEFINE VARIABLE iNewMinusTabPadding AS DECIMAL NO-UNDO.
            DO WHILE iTabFrameWidth[iShuffleFrame] + iWidthOfTab[iFrameFirstTab[iShuffleFrame] - 1] < IiFrameWidth: /* basic check */
                iCurrentShuffleTabPadding = (IiFrameWidth - iTabFrameWidth[iShuffleFrame]) / iNumTabsInFrame[iShuffleFrame].
                iCurrentMinusTabPadding = (IiFrameWidth - iTabFrameWidth[iShuffleFrame - 1]) / iNumTabsInFrame[iShuffleFrame - 1].
                iNewShuffleTabPadding = (IiFrameWidth - (iTabFrameWidth[iShuffleFrame] + iWidthOfTab[iFrameFirstTab[iShuffleFrame] - 1])) / (iNumTabsInFrame[iShuffleFrame] + 1).
                iNewMinusTabPadding = (IiFrameWidth - (iTabFrameWidth[iShuffleFrame - 1] - iWidthOfTab[iFrameFirstTab[iShuffleFrame] - 1])) / (iNumTabsInFrame[iShuffleFrame - 1] - 1).
                IF (iNewShuffleTabPadding + iNewMinusTabPadding) / 2 <= (iCurrentShuffleTabPadding + iCurrentMinusTabPadding) / 2
                THEN DO:
                    lShuffled = TRUE.
                    iFrameFirstTab[iShuffleFrame] = iFrameFirstTab[iShuffleFrame] - 1.
                    iTabFrameWidth[iShuffleFrame] = iTabFrameWidth[iShuffleFrame] + iWidthOfTab[iFrameFirstTab[iShuffleFrame]].
                    iTabFrameWidth[iShuffleFrame - 1] = iTabFrameWidth[iShuffleFrame - 1] - iWidthOfTab[iFrameFirstTab[iShuffleFrame]].
    
                    iNumTabsInFrame[iShuffleFrame] = iNumTabsInFrame[iShuffleFrame] + 1.
                    iNumTabsInFrame[iShuffleFrame - 1] = iNumTabsInFrame[iShuffleFrame - 1] - 1.
                END.
                ELSE LEAVE.
            END.
        END.
        IF NOT lShuffled
        THEN LEAVE shuffle-block.
    END.
    OcFrameLabels = "".
    iTabFrameCount = 0.
    DO iCount = 1 TO iLabels:
        IF  iTabFrameCount < {&max-tab-rows}
        AND iFrameFirstTab[iTabFrameCount + 1] = iCount
        THEN iTabFrameCount = iTabFrameCount + 1.
        OcFrameLabels[iTabFrameCount] = OcFrameLabels[iTabFrameCount] + "|" + ENTRY(iCount,IcFolderLabels,"|").
    END.
    
    DO iTabFrameCount = 1 TO iNumTabFrames:
        OcFrameLabels[iTabFrameCount] = SUBSTRING(OcFrameLabels[iTabFrameCount],2).
        
        IF iNumTabFrames > 1 /* Only pad out the labels for multi-row */
        THEN OiFramePadding[iTabFrameCount] = IiFrameWidth - iTabFrameWidth[iTabFrameCount].
    END.
    
END PROCEDURE.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ENDIF
&IF DEFINED(EXCLUDE-PBtnEventCursorLeft) = 0 &THEN
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE PBtnEventCursorLeft Method-Library 
PROCEDURE PBtnEventCursorLeft :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
    DEFINE VARIABLE iPos AS INTEGER NO-UNDO.
    
    /* What's this tab? */
    DO iPos = 1 TO LiNumTabs:
        IF LhTab[iPos] = SELF
        THEN LEAVE.
    END.
        
    iPos = iPos - 1.
    IF iPos = 0 THEN iPos = LiNumTabs.
    APPLY "ENTRY" TO LhTab[iPos].
    APPLY "MOUSE-SELECT-DOWN" TO LhTab[iPos].
    
END PROCEDURE.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ENDIF
&IF DEFINED(EXCLUDE-PBtnEventCursorRight) = 0 &THEN
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE PBtnEventCursorRight Method-Library 
PROCEDURE PBtnEventCursorRight :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
    DEFINE VARIABLE iPos AS INTEGER NO-UNDO.
    
    /* What's this tab? */
    DO iPos = 1 TO LiNumTabs:
        IF LhTab[iPos] = SELF
        THEN LEAVE.
    END.
    iPos = iPos + 1.
    IF iPos > LiNumTabs THEN iPos = 1.
    APPLY "ENTRY" TO LhTab[iPos].
    APPLY "MOUSE-SELECT-DOWN" TO LhTab[iPos].
    
END PROCEDURE.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ENDIF
&IF DEFINED(EXCLUDE-PBtnEventMouseSelectDown) = 0 &THEN
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE PBtnEventMouseSelectDown Method-Library 
PROCEDURE PBtnEventMouseSelectDown :
/*------------------------------------------------------------------------------
  Purpose:     Specifically the action of pressing the tab with the mouse
               and also hitting Enter on the button (instead of Choose)
  Parameters:  <none>
  Notes:       Also used by right and left cursor when focus is on tabs.
------------------------------------------------------------------------------*/
    DEFINE VARIABLE iCount AS INTEGER     NO-UNDO.
    DEFINE VARIABLE iThisPageNo AS INTEGER     NO-UNDO.
    
    /* Force any leave trigger to fire, and if focus hasn't moved, then assume leave trigger has been rejected */
    APPLY "ENTRY" TO SELF.
    IF FOCUS <> SELF
    THEN RETURN.
    /* Ensure all other "enabled" tabs are enabled */
    DO iCount = 1 TO {&max-labels}:
        IF VALID-HANDLE(LhTab[iCount])
        AND LhTab[iCount] <> SELF
        AND LhTab[iCount]:PRIVATE-DATA <> "DISABLED"
        THEN LhTab[iCount]:SENSITIVE = TRUE.
        IF LhTab[iCount] = SELF
        THEN iThisPageNo = iCount.
    END.
    /* Let this be done by the change page for now 
    /* Update the tab visualisation */
    RUN PUpdateTabVisualisation(iThisPageNo).
    */
    
    LlClickActive = TRUE.
        
    /* Select the page */
    RUN {&PSelectPage} IN LhContainer (INPUT iThisPageNo) NO-ERROR. /* Visualisation is actually done by the container telling the tab to change, not here */
    LlClickActive = FALSE.
    /* Re-apply ENTRY to SELF - to ensure that the focus is on the tab */
    /* APPLY "ENTRY" TO SELF. - whilst using an overlay button, comment out */
    APPLY "ENTRY" TO LhOverlayButton.
END PROCEDURE.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ENDIF
&IF DEFINED(EXCLUDE-PCreateTabs) = 0 &THEN
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE PCreateTabs Method-Library 
PROCEDURE PCreateTabs :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
    DEFINE INPUT PARAMETER IcLabels AS CHARACTER NO-UNDO.
    
    /* create all tabs */      
    DEFINE VARIABLE iCount AS INTEGER NO-UNDO.
    DEFINE VARIABLE cLabel AS CHARACTER NO-UNDO.
    DEFINE VARIABLE iTotalCount AS INTEGER NO-UNDO.
    DO iCount = 1 TO {&max-labels}:
        IF VALID-HANDLE(LhTab[iCount])
        THEN DELETE OBJECT LhTab[iCount].
    END.
    DO iCount = 1 TO LiNumTabFrames:
        DELETE OBJECT LhTabFrame[iCount].
    END.
    DEFINE VARIABLE cTabFrameLabels AS CHARACTER EXTENT {&max-tab-rows} NO-UNDO.
    DEFINE VARIABLE iTabFramePadding AS INTEGER EXTENT {&max-tab-rows} NO-UNDO.
    RUN PAssignTabsToFrames(INPUT IcLabels,
                            INPUT FRAME {&FRAME-NAME}:WIDTH-PIXELS - 4,
                            OUTPUT cTabFrameLabels,
                            OUTPUT iTabFramePadding).
        
    DEFINE VARIABLE iTabFrame AS INTEGER NO-UNDO INITIAL 0.
    DEFINE VARIABLE iButtonWidthPixels AS INTEGER NO-UNDO.
    DEFINE VARIABLE iTabFramePositionPixels AS INTEGER NO-UNDO INITIAL 10000.
    DO iTabFrame = 1 TO {&max-tab-rows}:
        IF cTabFrameLabels[iTabFrame] = "" THEN LEAVE.
        LiNumTabFrames = iTabFrame. /* Just increment until it is set */ 
        CREATE FRAME LhTabFrame[iTabFrame]
             ASSIGN FRAME = FRAME {&FRAME-NAME}:HANDLE
                    FONT = 10
                    BGCOLOR = (IF LlOnTabFrame THEN 31 ELSE ?)
                    THREE-D = TRUE
                    WIDTH-PIXELS = FRAME {&FRAME-NAME}:WIDTH-PIXELS - 2
                    HEIGHT-PIXELS = {&button-frame-height}
                    X = 2
                    Y = 2 + ( ({&button-frame-height} - {&button-frame-overlap}) * (iTabFrame - 1))
                    BOX = FALSE
                    /* VISIBLE = TRUE */
                    HIDDEN = FALSE
                    .
        iTabFramePositionPixels = 0.
        DEFINE VARIABLE iNumFrameTabs AS INTEGER NO-UNDO.
        
        iNumFrameTabs = NUM-ENTRIES(cTabFrameLabels[iTabFrame],"|").
        DO iCount = 1 TO iNumFrameTabs:
             iTotalCount = iTotalCount + 1.
             /* + INTEGER(ROUND(iCount * iTabFramePadding[iCount] / iNumFrameTabs,0) - ROUND((iCount - 1) * iTabFramePadding[iCount] / iNumFrameTabs,0)) */
             cLabel = ENTRY(iCount,cTabFrameLabels[iTabFrame],"|").
             DEFINE VARIABLE iButtonPadding AS INTEGER NO-UNDO.  /* For readability/debugging */
             iButtonPadding = ROUND(iCount * iTabFramePadding[iTabFrame] / iNumFrameTabs,0) - ROUND((iCount - 1) * iTabFramePadding[iTabFrame] / iNumFrameTabs,0).
                          
             CREATE BUTTON LhTab[iTotalCount]
               ASSIGN LABEL = cLabel
                      PRIVATE-DATA = STRING(iTotalCount)
                      WIDTH-PIXELS = FONT-TABLE:GET-TEXT-WIDTH-PIXELS(cLabel,10) + 12 + iButtonPadding
                      HEIGHT-PIXELS = ({&button-frame-height} - 1)
                      FRAME = LhTabFrame[iTabFrame]
                      X = iTabFramePositionPixels
                      Y = 0
                      VISIBLE = TRUE
                      SENSITIVE = TRUE
                      TAB-STOP = FALSE /* Whilst using overlay button */
                TRIGGERS:
                    ON MOUSE-SELECT-DOWN PERSISTENT RUN PBtnEventMouseSelectDown IN THIS-PROCEDURE.
                    ON RETURN PERSISTENT RUN PBtnEventMouseSelectDown IN THIS-PROCEDURE.
                    ON CURSOR-LEFT PERSISTENT RUN PBtnEventCursorLeft IN THIS-PROCEDURE.
                    ON CURSOR-RIGHT PERSISTENT RUN PBtnEventCursorRight IN THIS-PROCEDURE.
                END.
             iTabFramePositionPixels = iTabFramePositionPixels + LhTab[iTotalCount]:WIDTH-PIXELS - 1.
        END.
    END.
    LiNumTabs = iTotalCount.
    
    /* LhOverlayButton:MOVE-TO-TOP(). */
    /* Nice to have - create tab-bottom frame - which covers top of frame-A - looks like tab! */
    &IF {&button-frame-overlap} > 0 AND {&selected-button-on-bottom-row}
    &THEN
    
    IF NOT VALID-HANDLE(LhTabBottomFrame)
    THEN DO:
        IF VALID-HANDLE(LhTab[1]) THEN
        CREATE FRAME LhTabBottomFrame
            ASSIGN FRAME = FRAME {&FRAME-NAME}:HANDLE
                        WIDTH-PIXELS = LhTab[1]:WIDTH-PIXELS - 3
                        HEIGHT-PIXELS = 20
                        THREE-D = TRUE
                        /* THREE-D = FRAME FRAME-A:THREE-D */
                        /* BGCOLOR = FRAME FRAME-A:BGCOLOR */
                        BGCOLOR = LhBackgroundFrame:BGCOLOR
                        BOX = FALSE
                        VISIBLE = TRUE
                        SCROLLABLE = FALSE
                        X = 3
                        Y = (({&button-frame-height} - {&button-frame-overlap}) * LiNumTabFrames) + 1
             .
    END.
    ELSE LhTabBottomFrame:Y = (({&button-frame-height} - {&button-frame-overlap}) * LiNumTabFrames) + 1.
    
    IF VALID-HANDLE(LhTabBottomFrame) /* Only occurs if no tabs on initialisation - e.g. in Homelessness case processing */
    THEN LhTabBottomFrame:MOVE-TO-TOP().
    &ENDIF
END PROCEDURE.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ENDIF
&IF DEFINED(EXCLUDE-PMoveSelectedTabFrameToBottomRow) = 0 &THEN
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE PMoveSelectedTabFrameToBottomRow Method-Library 
PROCEDURE PMoveSelectedTabFrameToBottomRow :
/*------------------------------------------------------------------------------
  Purpose:     Moves the specified tab frame to the "front" - which is the bottom
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
    
    DEFINE INPUT PARAMETER IhTabFrame AS HANDLE NO-UNDO.
    
    DEFINE VARIABLE iCount AS INTEGER NO-UNDO.
    DEFINE VARIABLE iFrameIndex AS INTEGER NO-UNDO.
    DEFINE VARIABLE iFrame AS INTEGER NO-UNDO.
    
    /* IF LiNumTabFrames > 1 /* Do nothing if only one tab frame */ */
    IF IhTabFrame <> LhBottomRowTabFrame
    THEN DO:
        /* Find the frame index */
        DO iCount = 1 TO LiNumTabFrames:
            IF IhTabFrame = LhTabFrame[iCount]
            THEN iFrameIndex = iCount.
        END.
        /* Reposition the frames (if necessary) */
        DO iCount = 1 TO LiNumTabFrames.
            
            /* Which frame? */
            iFrame = (((iCount + iFrameIndex) - 2) MODULO LiNumTabFrames) + 1. /* Do an example to work it out! */
            /* LhTabFrame[iFrame]:Y = (20 * ((LiNumTabFrames - iCount) + 1)) - 19. /* Need to put the front screen at the bottom */ */
            LhTabFrame[iFrame]:Y = (18 * ((LiNumTabFrames - iCount) + 1)) - 15. /* Need to put the front screen at the bottom */
            LhTabFrame[iFrame]:MOVE-TO-BOTTOM().

            /* Logic of 2 above statements could be combined */
        END.
        LhBottomRowTabFrame = IhTabFrame.
    END.
END PROCEDURE.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ENDIF
&IF DEFINED(EXCLUDE-POverlayBtnEventCursorLeft) = 0 &THEN
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE POverlayBtnEventCursorLeft Method-Library 
PROCEDURE POverlayBtnEventCursorLeft :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
    APPLY "CURSOR-LEFT" TO LhTab[INTEGER(SELF:PRIVATE-DATA)].
END PROCEDURE.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ENDIF
&IF DEFINED(EXCLUDE-POverlayBtnEventCursorRight) = 0 &THEN
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE POverlayBtnEventCursorRight Method-Library 
PROCEDURE POverlayBtnEventCursorRight :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
    APPLY "CURSOR-RIGHT" TO LhTab[INTEGER(SELF:PRIVATE-DATA)].
END PROCEDURE.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ENDIF
&IF DEFINED(EXCLUDE-PSetTabSensitivity) = 0 &THEN
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE PSetTabSensitivity Method-Library 
PROCEDURE PSetTabSensitivity :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
    /* parameters */
    DEFINE INPUT    PARAMETER IiPage#       AS      INTEGER     NO-UNDO.
    DEFINE INPUT    PARAMETER IiSensitive   AS      LOGICAL     NO-UNDO.
    /* main body */
    IF VALID-HANDLE(LhTab[IiPage#]) THEN
    ASSIGN LhTab[IiPage#]:SENSITIVE = IiSensitive
           LhTab[IiPage#]:PRIVATE-DATA = TRIM(STRING(IiSensitive,"ENABLED/DISABLED"))
           .
    IF LiCurrentTab = IiPage#
    THEN LhOverlayButton:SENSITIVE = IiSensitive.
END PROCEDURE.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ENDIF
&IF DEFINED(EXCLUDE-PUpdateTabVisualisation) = 0 &THEN
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE PUpdateTabVisualisation Method-Library 
PROCEDURE PUpdateTabVisualisation :
/*------------------------------------------------------------------------------
  Purpose:     Only changes the tab visualisation
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
    DEFINE INPUT PARAMETER IiTab AS INTEGER NO-UNDO.
    
    DEFINE VARIABLE iClassicAdjustment AS INTEGER NO-UNDO.
        
    /* !!! Switch off this feature for now - looks better without it !!!
    /* Disable this one */
    LhTab[IiTab]:SENSITIVE = FALSE.
    */                                                                     
                                                                    
    /* Windows is slow to respond, and displays scroll bars on the tab frame unless you hide it first - a "feature" of Progress on Windows
    even though the frame is not scrollable.  Tried lots of things - including setting to careful paint, but none seemed to work, so resorted to hiding
    before moving - like with the tab bottom frame.
    This then requires a background frame MOVE-TO-TOP() statement later */
    IF IiTab <> LiCurrentTab
    THEN LhOverlayButtonFrame:HIDDEN = TRUE.
        
    /* Reorder the tab frames (if necessary) */
    RUN PMoveSelectedTabFrameToBottomRow IN THIS-PROCEDURE (INPUT LhTab[IiTab]:FRAME).
    ASSIGN LhOverlayButton:HEIGHT-PIXELS = LhTab[IiTab]:HEIGHT-PIXELS
           LhOverlayButtonFrame:HEIGHT-PIXELS = LhTab[IiTab]:HEIGHT-PIXELS
           .
    IF LhOverlayButton:WIDTH-PIXELS > LhTab[IiTab]:WIDTH-PIXELS + 4 
    THEN DO:
        LhOverlayButton:WIDTH-PIXELS = LhTab[IiTab]:WIDTH-PIXELS + 4.
        LhOverlayButtonFrame:WIDTH-PIXELS = LhOverlayButton:WIDTH-PIXELS.
    END.
    
    ASSIGN  LhOverlayButtonFrame:X = LhTab[IiTab]:X
            LhOverlayButtonFrame:Y = (18 * LiNumTabFrames) - 17 /* Need to put the front screen at the bottom */
            LhOverlayButton:LABEL = LhTab[IiTab]:LABEL + " "
            LhOverlayButton:SENSITIVE = LhTab[IiTab]:SENSITIVE
            LhOverlayButton:PRIVATE-DATA = STRING(IiTab)
            .
    IF LhOverlayButton:WIDTH-PIXELS < LhTab[IiTab]:WIDTH-PIXELS + 4
    THEN DO:
        LhOverlayButtonFrame:WIDTH-PIXELS = LhTab[IiTab]:WIDTH-PIXELS + 4.
        LhOverlayButton:WIDTH-PIXELS = LhOverlayButtonFrame:WIDTH-PIXELS.
    END.
    IF IiTab <> LiCurrentTab
    THEN LhOverlayButtonFrame:VISIBLE = TRUE. /* Re-show if necessary */
    /* When necessary, grey the "bottom" of current selected tab */
    IF VALID-HANDLE(LhTabBottomFrame)
    THEN DO:
        IF SESSION:WINDOW-SYSTEM="MS-WIN95"
        THEN iClassicAdjustment = 1.
        /* Only do anything if necessary - to prevent flashing */
        IF  LhTabBottomFrame:WIDTH-PIXELS <> LhTab[IiTab]:WIDTH-PIXELS /* + iClassicAdjustment */
        OR  LhTabBottomFrame:X <> LhTab[IiTab]:X + 2 - iClassicAdjustment
        THEN DO:
            LhTabBottomFrame:VISIBLE = FALSE. /* Hide, because occassionally you see the windows frame resizing bars */
            IF LhTabBottomFrame:WIDTH-PIXELS > LhTab[IiTab]:WIDTH-PIXELS /* + iClassicAdjustment */ /* Getting smaller */
            THEN DO:
                /* Shrink first, then move */
                LhTabBottomFrame:WIDTH-PIXELS = LhTab[IiTab]:WIDTH-PIXELS /* + iClassicAdjustment */.
                LhTabBottomFrame:X = LhTab[IiTab]:X + 2 - iClassicAdjustment.
            END.
            ELSE DO:
                /* Move first, then enlarge */
                LhTabBottomFrame:X = LhTab[IiTab]:X + 2 - iClassicAdjustment.
                LhTabBottomFrame:WIDTH-PIXELS = LhTab[IiTab]:WIDTH-PIXELS /* + iClassicAdjustment */.
            END.
            LhTabBottomFrame:HIDDEN = FALSE.
        END.
        LhBackgroundFrame:MOVE-TO-TOP(). /* Hiding and viewing the overlay tab frame makes this necessary */
        LhTabBottomFrame:MOVE-TO-TOP(). /* Ensure it overlays the tab frames which may have moved */
    END.
    LiCurrentTab = IiTab.
END PROCEDURE.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ENDIF
