/*
 * Copyright 2016-2017 Golden Code Development Corporation
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software
 * and associated documentation files (the "Software"),  to deal in the Software without
 * restriction, including without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or
 * substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
 * BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

procedure inMsg_notifyEHotelDisconnect.
   quit.
end.

procedure doLogin.
   def input param messageId as int.
   def input param username as char.
   def input param password as char.

   if setuserid(username, password) then do:
      P2J-REMOTE-CALL('~{ "api":"p2jInitialized" ~}').
   end.
   else do:
      P2J-REMOTE-CALL('~{ "api":"showError" , "error":"Invalid username or password" ~}').
   end.
end.

def new global shared var wWin as handle.

{src/adm2/containr.i}

RUN start-super-proc("adm2/containr.p":U).
RUN start-super-proc ("adm2/smart.p":U).

CREATE WINDOW wWin ASSIGN
       HIDDEN             = YES
       TITLE              = "Hotel Demo FWD Application"
       HEIGHT             = 17.71
       WIDTH              = 126
       MAX-HEIGHT         = 28.81
       MAX-WIDTH          = 174.6
       VIRTUAL-HEIGHT     = 28.81
       VIRTUAL-WIDTH      = 174.6
       RESIZE             = no
       SCROLL-BARS        = no
       STATUS-AREA        = no
       BGCOLOR            = ?
       FGCOLOR            = ?
       THREE-D            = yes
       MESSAGE-AREA       = no
       FONT               = 8
       SENSITIVE          = yes.

ASSIGN CURRENT-WINDOW  = wWin 
    wWin:KEEP-FRAME-Z-ORDER = YES
    THIS-PROCEDURE:CURRENT-WINDOW = wWin.
view wWin.

wait-for close of this-procedure.
