/*
 * Copyright 2016-2017 Golden Code Development Corporation
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software
 * and associated documentation files (the "Software"),  to deal in the Software without
 * restriction, including without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or
 * substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
 * BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

def new global shared var u-name as char.
DEFINE VARIABLE hSmartWindow AS HANDLE NO-UNDO.

def var uname as char.
def var upass as char.
def var safe-name as char.

DEFINE VAR hwindow AS HANDLE.
CREATE WINDOW hwindow ASSIGN
            TITLE  = "Hotel Login"
            RESIZE = no.

hwindow:MESSAGE-AREA = FALSE.
hwindow:STATUS-AREA = TRUE.

DEFINE IMAGE logo FILE "graphics/hotel-login.jpg".
DEFINE BUTTON exit NO-FOCUS
     LABEL "Exit"
     SIZE 10 BY .91.
DEFINE FRAME f-logo logo exit AT X 588 Y 1 WITH SIZE-PIXELS 642 by 449.

hwindow:MESSAGE-AREA = FALSE.
hwindow:WIDTH-PIXELS = 642.
hwindow:height-pixels = 449.

form uname format "x(25)" label "User Name"  help "Default user/pw is hotel/hotel" at row 1 col 13 colon-aligned
     skip
     upass format "x(25)" label "Password" password-field help "Default user/pw is hotel/hotel" at row 2 col 13 colon-aligned
   with frame f-login side-labels.

FRAME f-login:FRAME = FRAME f-logo:HANDLE.
frame f-login:y = 240.
frame f-login:X = 90.

u-name = ?.

ON RETURN OF uname
DO:
   APPLY "ENTRY":U TO upass.
   RETURN NO-APPLY.
END.

ON RETURN OF upass
DO:
   APPLY "GO":U TO FRAME f-login.
   RETURN NO-APPLY.
END.

ON CHOOSE OF exit
DO:
   QUIT.
END.

repeat on endkey undo, next
       on error undo, next
       on stop undo, next:

   /* logout */
   IF VALID-HANDLE(hSmartWindow) THEN APPLY "CLOSE" TO hSmartWindow.
   setuserid("", "").
   u-name = ?.

   hwindow:visible = true.
   view frame f-logo in window hwindow.
   ENABLE exit WITH FRAME f-logo in window hwindow.

   update uname upass with frame f-login in window hwindow.

   if setuserid(uname, upass) then do:
      uname = "".
      upass = "".
      clear frame f-login all no-pause.
      u-name = userid.
      RUN main-window.w PERSISTENT SET hSmartWindow.
      RUN initializeObject IN hSmartWindow.
      hwindow:visible = false.
      wait-for close of hSmartWindow.
      next.
   end.
   else do:
      safe-name = if uname eq ? then "?" else uname.
      safe-name = if length(safe-name) eq 0 then "''" else safe-name.
      message "Invalid userid (" + safe-name + ") or password." view-as alert-box INFORMATION
      BUTTONS OK.
      next.
   end.
end.

wait-for close of hwindow.
